package labss.lang.il.model.impl;

import labss.lang.il.visitors.ILVisitor;

public class Bool extends AbstractLiteral {
	// Singleton
	public static final Bool TRUE = new Bool(true);
	public static final Bool FALSE = new Bool(false);
	public static final Bool instance(boolean value) {
		return value ? TRUE: FALSE;
	}

	private boolean val;
	private Bool(boolean val) {
		this.val = val;
	}

	public boolean isVal() {
		return val;
	}

	public void setVal(boolean val) {
		this.val = val;
	}

	public boolean booleanValue() {
		return val;
	}

	public String toString() {
		return String.valueOf(val);
	}

	public void accept(ILVisitor visitor) {
		visitor.visit(this);
	}
}