package labss.lang.il.visitors;

import labss.lang.il.model.*;
import labss.lang.il.model.impl.*;

public class ILIdentityDefaultVisitor implements ILVisitor {
	protected void visitILEntity(ILEntity entity) {}
	protected void visitStatement(Statement stm) {
		visitILEntity(stm);
	}
	protected void visitExpression(Expression exp) {
		visitILEntity(exp);
	}
	protected void visitLiteral(Literal exp) {
		visitExpression(exp);
	}

	public void visit(While stm) {
		visitStatement(stm);
	}

	public void visit(If stm) {
		visitStatement(stm);
	}

	public void visit(IfElse stm) {
		visitStatement(stm);
	}

	public void visit(Empty stm) {
		visitStatement(stm);
	}

	public void visit(Assignment stm) {
		visitStatement(stm);
	}

	public void visit(Block stm) {
		visitStatement(stm);
	}

	public void visit(Bool exp) {
		visitLiteral(exp);
	}

	public void visit(Int exp) {
		visitLiteral(exp);
	}

	public void visit(Variable exp) {
		visitExpression(exp);
	}

	public void visit(Addition exp) {
		visitExpression(exp);
	}

	public void visit(Subtraction exp) {
		visitExpression(exp);
	}

	public void visit(Multiplication exp) {
		visitExpression(exp);
	}

	public void visit(Division exp) {
		visitExpression(exp);
	}

	public void visit(Equals exp) {
		visitExpression(exp);
	}

	public void visit(GreaterThan exp) {
		visitExpression(exp);
	}

	public void visit(LessThan exp) {
		visitExpression(exp);
	}

	public void visit(And exp) {
		visitExpression(exp);
	}

	public void visit(Or exp) {
		visitExpression(exp);
	}

	public void visit(Not exp) {
		visitExpression(exp);
	}
}
