package labss.lang.il.visitors;

import labss.lang.il.model.*;
import labss.lang.il.model.impl.*;

public class ILTraverseAllVisitor extends ILIdentityVisitor {
	protected ILVisitor visitor1;

	public void wSetVisitor1(ILVisitor visitor) {
		this.visitor1 = visitor;
	}

	public ILTraverseAllVisitor() {
		wSetVisitor1(this);
	}
	public ILTraverseAllVisitor(ILVisitor visitor) {
		wSetVisitor1(visitor1);
	}

	public void visit(Block entity) {
		for (Statement s : entity.getStatements())
			s.accept(visitor1);
	}

	public void visit(If entity) {
		entity.getCondition().accept(visitor1);
		entity.getTrueBody().accept(visitor1);
	}

	public void visit(IfElse entity) {
		entity.getCondition().accept(visitor1);
		entity.getTrueBody().accept(visitor1);
		entity.getFalseBody().accept(visitor1);
	}

	public void visit(While entity) {
		entity.getCondition().accept(visitor1);
		entity.getTrueBody().accept(visitor1);
	}

	public void visit(Assignment entity) {
		entity.getVariable().accept(visitor1);
		entity.getExpression().accept(visitor1);
	}

	public void visit(Addition entity) {
		entity.getExp1().accept(visitor1);
		entity.getExp2().accept(visitor1);
	}

	public void visit(Subtraction entity) {
		entity.getExp1().accept(visitor1);
		entity.getExp2().accept(visitor1);
	}

	public void visit(Multiplication entity) {
		entity.getExp1().accept(visitor1);
		entity.getExp2().accept(visitor1);
	}

	public void visit(Division entity) {
		entity.getExp1().accept(visitor1);
		entity.getExp2().accept(visitor1);
	}

	public void visit(And entity) {
		entity.getExp1().accept(visitor1);
		entity.getExp2().accept(visitor1);
	}

	public void visit(Or entity) {
		entity.getExp1().accept(visitor1);
		entity.getExp2().accept(visitor1);
	}

	public void visit(Not entity) {
		entity.getExp().accept(visitor1);
	}

	public void visit(Equals entity) {
		entity.getExp1().accept(visitor1);
		entity.getExp2().accept(visitor1);
	}

	public void visit(LessThan entity) {
		entity.getExp1().accept(visitor1);
		entity.getExp2().accept(visitor1);
	}

	public void visit(GreaterThan entity) {
		entity.getExp1().accept(visitor1);
		entity.getExp2().accept(visitor1);
	}
}
