package labss.lang.il.visitors;

import java.io.PrintStream;

public class LineIndentationStrategy implements IndentationStrategy {
	private IndentationStrategy baseStrategy;
	private int lineNumber = 1;

	public LineIndentationStrategy() {
		this(new SpaceIndentationStrategy(4));
	}
	public LineIndentationStrategy(IndentationStrategy baseStrategy) {
		this.baseStrategy = baseStrategy;
	}

	public void printIndentation(PrintStream out) {
		out.printf("%4s ", lineNumber++);
		baseStrategy.printIndentation(out);
	}
	public void startIndentationPart(Kind kind) {
		baseStrategy.startIndentationPart(kind);
	}
	public void endIndentationPart() {
		baseStrategy.endIndentationPart();
	}
}
