package labss.lang.il.visitors;

import java.io.PrintStream;

public class SpaceIndentationStrategy implements IndentationStrategy {
	private final String indentationString = "                                ";
	protected int indentationSize;
	protected int indentation = 0;

	public SpaceIndentationStrategy() {
		this(4);
	}
	public SpaceIndentationStrategy(int indentationSize) {
		this.indentationSize = indentationSize;
	}

	public void printIndentation(PrintStream out) {
		if (indentation > 0) {
			if (indentation * indentationSize < indentationString.length())
				out.print(indentationString.substring(0, indentation * indentationSize));
			else
				out.print(indentationString);
		}
	}

	public void startIndentationPart(Kind kind) {
		indentation++;
	}
	public void endIndentationPart() {
		indentation--;
	}
}
